import { ElementRef, EventEmitter } from '@angular/core';
import { ColorGradientType, RadialColorGradientSizeType } from 'soid-ui-util';
import { DomSanitizer } from '@angular/platform-browser';
import { MatIconRegistry } from '@angular/material/icon';
import { Color } from 'ngx-color';
import * as i0 from "@angular/core";
export declare class TowifyEditorColorPickerComponent {
    #private;
    private readonly sanitizer;
    private readonly matIconRegistry;
    currentType?: 'color' | 'linear' | 'radial' | 'overlay';
    width: number;
    set gradientInfo(info: ColorGradientType | undefined);
    get gradientInfo(): ColorGradientType | undefined;
    colorInfo: {
        color: string;
        opacity: number;
    };
    onGradientChangeComplete: EventEmitter<ColorGradientType>;
    onGradientChange: EventEmitter<ColorGradientType>;
    onColorChange: EventEmitter<{
        color: string;
        opacity: number;
    }>;
    onColorChangeComplete: EventEmitter<{
        color: string;
        opacity: number;
    }>;
    onButtonToggleChanged: EventEmitter<"linear" | "color" | "radial" | "overlay">;
    gradientCanvas?: ElementRef<HTMLCanvasElement>;
    backgroundSettings: {
        icon: string;
        name: string;
        type: 'color' | 'linear' | 'radial' | 'overlay';
    }[];
    radialInfo: {
        type: RadialColorGradientSizeType;
        icon: string;
        name: string;
        description: string;
    }[];
    gradientAddCursor: string;
    selectedColorIndex: number;
    dragItemHeight: number;
    defaultGradient: ColorGradientType;
    dragPointPosition: {
        x: number;
        y: number;
    };
    dragOperatorButtonPosition: {
        x: number;
        y: number;
    };
    constructor(sanitizer: DomSanitizer, matIconRegistry: MatIconRegistry);
    onColorChanging(info: {
        color: string;
        opacity: number;
    }): void;
    onColorChanged(info: {
        color: string;
        opacity: number;
    }): void;
    onGradientChanging(): void;
    onGradientChanged(): void;
    switchBoardByType(type: 'linear' | 'radial' | 'color' | 'overlay'): void;
    prepareCanvas(): void;
    private resetGradientInfo;
    initSpinButtonDragEvent(element: HTMLElement): void;
    initPositionOperatorButtonDragEvent(element: HTMLElement): void;
    onAngleChanged(angle: number | null, needToSync?: boolean): void;
    onRadialLeftPositionChanged(left: number): void;
    onRadialTopPositionChanged(top: number): void;
    addColorGradient(event: MouseEvent): void;
    reverseColorGradient(): void;
    onSelectedColorChange(color: Color, needToSync?: boolean): void;
    onSelectedPercentChange(percent: number | null, isListening?: boolean): void;
    private initGradientItemDragEvent;
    private changeDragOperatorButtonPosition;
    private sortColor;
    private drawCanvasGradient;
    static ɵfac: i0.ɵɵFactoryDeclaration<TowifyEditorColorPickerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TowifyEditorColorPickerComponent, "towify-editor-color-picker", never, { "currentType": "currentType"; "width": "width"; "gradientInfo": "gradientInfo"; "colorInfo": "colorInfo"; }, { "onGradientChangeComplete": "onGradientChangeComplete"; "onGradientChange": "onGradientChange"; "onColorChange": "onColorChange"; "onColorChangeComplete": "onColorChangeComplete"; "onButtonToggleChanged": "onButtonToggleChanged"; }, never, never>;
}
